diff --git a/src/actionManager.cpp b/src/actionManager.cpp
index 3103eb4..8fa5ee7 100644
--- a/src/actionManager.cpp
+++ b/src/actionManager.cpp
@@ -612,3 +527,164 @@ QMenu *NActionManager::trayIconMenu()
 {
     return m_trayIconMenu;
 }
+
+// Slot implementations for lambdas converted for Qt4 compatibility
+
+void NActionManager::on_showCoverAction_toggled(bool checked)
+{
+    m_player->settings()->setValue("ShowCoverArt", checked);
+    m_player->coverWidget()->setVisible(checked);
+}
+
+void NActionManager::on_playingOnTopAction_toggled(bool checked)
+{
+    m_player->settings()->setValue("WhilePlayingOnTop", checked);
+
+    bool alwaysOnTop = m_player->settings()->value("AlwaysOnTop").toBool();
+    if (!alwaysOnTop) {
+        m_player->mainWindow()->setOnTop(checked && m_player->playbackEngine()->state() ==
+                                                      N::PlaybackPlaying);
+    }
+}
+
+void NActionManager::on_alwaysOnTopAction_toggled(bool checked)
+{
+    m_player->settings()->setValue("AlwaysOnTop", checked);
+
+    bool whilePlaying = m_player->settings()->value("WhilePlayingOnTop").toBool();
+    if (!whilePlaying || m_player->playbackEngine()->state() != N::PlaybackPlaying) {
+        m_player->mainWindow()->setOnTop(checked);
+    }
+}
+
+void NActionManager::on_loopPlaylistAction_triggered(bool checked)
+{
+    m_player->settings()->setValue("LoopPlaylist", checked);
+}
+
+void NActionManager::on_scrollToItemPlaylistAction_triggered(bool checked)
+{
+    m_player->settings()->setValue("ScrollToItem", checked);
+}
+
+void NActionManager::on_nextFileEnableAction_triggered(bool checked)
+{
+    m_player->settings()->setValue("LoadNext", checked);
+}
+
+void NActionManager::on_nextFileByNameAscdAction_triggered(bool checked)
+{
+    Q_UNUSED(checked);
+    m_player->settings()->setValue("LoadNextSort", (int)QDir::Name);
+}
+
+void NActionManager::on_nextFileByNameDescAction_triggered(bool checked)
+{
+    Q_UNUSED(checked);
+    m_player->settings()->setValue("LoadNextSort", (int)(QDir::Name | QDir::Reversed));
+}
+
+void NActionManager::on_nextFileByDateAscdAction_triggered(bool checked)
+{
+    Q_UNUSED(checked);
+    m_player->settings()->setValue("LoadNextSort", (int)(QDir::Time | QDir::Reversed));
+}
+
+void NActionManager::on_nextFileByDateDescAction_triggered(bool checked)
+{
+    Q_UNUSED(checked);
+    m_player->settings()->setValue("LoadNextSort", (int)(QDir::Time));
+}
+
+void NActionManager::on_revealAction_triggered()
+{
+    QStringList files = m_player->playlistWidget()->selectedFiles();
+    if (files.isEmpty()) {
+        return;
+    }
+
+    QString error;
+    if (!m_player->revealInFileManager(files.first(), &error)) {
+        QMessageBox::warning(m_player->mainWindow(), tr("Reveal in File Manager Error"),
+                             error, QMessageBox::Close);
+    }
+}
+
+void NActionManager::on_trashSelectedAction_triggered()
+{
+    QStringList files = m_player->playlistWidget()->selectedFiles();
+    if (files.isEmpty()) {
+        return;
+    }
+
+    QStringList deleted = NTrash::moveToTrash(files);
+    m_player->playlistWidget()->removeFiles(deleted);
+}
+
+void NActionManager::on_tagEditorAction_triggered()
+{
+    QStringList files = m_player->playlistWidget()->selectedFiles();
+    if (files.isEmpty()) {
+        return;
+    }
+
+    m_player->showTagEditor(files.first());
+}
+
+void NActionManager::on_jumpForwardAction_triggered()
+{
+    qint64 num = 10 * 1000;
+    m_player->playbackEngine()->jump(num);
+}
+
+void NActionManager::on_jumpBackwardsAction_triggered()
+{
+    qint64 num = 10 * 1000;
+    m_player->playbackEngine()->jump(-num);
+}
+
+void NActionManager::on_speedIncreaseAction_triggered()
+{
+    qreal newSpeed = qMax(0.01, m_player->playbackEngine()->speed() +
+                                    m_player->settings()->value("SpeedStep").toDouble());
+    m_player->playbackEngine()->setSpeed(newSpeed);
+    m_player->showToolTip(tr("Speed: %1").arg(m_player->playbackEngine()->speed()));
+}
+
+void NActionManager::on_speedDecreaseAction_triggered()
+{
+    qreal newSpeed = qMax(0.01, m_player->playbackEngine()->speed() -
+                                    m_player->settings()->value("SpeedStep").toDouble());
+    m_player->playbackEngine()->setSpeed(newSpeed);
+    m_player->showToolTip(tr("Speed: %1").arg(m_player->playbackEngine()->speed()));
+}
+
+void NActionManager::on_speedResetAction_triggered()
+{
+    qreal newSpeed = 1.0;
+    m_player->playbackEngine()->setSpeed(newSpeed);
+    m_player->showToolTip(tr("Speed: %1").arg(m_player->playbackEngine()->speed()));
+}
+
+void NActionManager::on_pitchIncreaseAction_triggered()
+{
+    qreal newPitch = qMax(0.01, m_player->playbackEngine()->pitch() +
+                                    m_player->settings()->value("PitchStep").toDouble());
+    m_player->playbackEngine()->setPitch(newPitch);
+    m_player->showToolTip(tr("Pitch: %1").arg(m_player->playbackEngine()->pitch()));
+}
+
+void NActionManager::on_pitchDecreaseAction_triggered()
+{
+    qreal newPitch = qMax(0.01, m_player->playbackEngine()->pitch() -
+                                    m_player->settings()->value("PitchStep").toDouble());
+    m_player->playbackEngine()->setPitch(newPitch);
+    m_player->showToolTip(tr("Pitch: %1").arg(m_player->playbackEngine()->pitch()));
+}
+
+void NActionManager::on_pitchResetAction_triggered()
+{
+    qreal newPitch = 1.0;
+    m_player->playbackEngine()->setPitch(newPitch);
+    m_player->showToolTip(tr("Pitch: %1").arg(m_player->playbackEngine()->pitch()));
+}
diff --git a/src/actionManager.h b/src/actionManager.h
index c43ea20..296fd43 100644
--- a/src/actionManager.h
+++ b/src/actionManager.h
@@ -32,6 +32,29 @@ public:
     QMenu *playlistContextMenu();
     QMenu *trayIconMenu();
 
+private slots:
+    void on_showCoverAction_toggled(bool checked);
+    void on_playingOnTopAction_toggled(bool checked);
+    void on_alwaysOnTopAction_toggled(bool checked);
+    void on_loopPlaylistAction_triggered(bool checked);
+    void on_scrollToItemPlaylistAction_triggered(bool checked);
+    void on_nextFileEnableAction_triggered(bool checked);
+    void on_nextFileByNameAscdAction_triggered(bool checked);
+    void on_nextFileByNameDescAction_triggered(bool checked);
+    void on_nextFileByDateAscdAction_triggered(bool checked);
+    void on_nextFileByDateDescAction_triggered(bool checked);
+    void on_revealAction_triggered();
+    void on_trashSelectedAction_triggered();
+    void on_tagEditorAction_triggered();
+    void on_jumpForwardAction_triggered();
+    void on_jumpBackwardsAction_triggered();
+    void on_speedIncreaseAction_triggered();
+    void on_speedDecreaseAction_triggered();
+    void on_speedResetAction_triggered();
+    void on_pitchIncreaseAction_triggered();
+    void on_pitchDecreaseAction_triggered();
+    void on_pitchResetAction_triggered();
+
 private:
     NPlayer *m_player;
     QMenu *m_contextMenu;
diff --git a/src/common.cpp b/src/common.cpp
index b625651..c9c5862 100644
--- a/src/common.cpp
+++ b/src/common.cpp
@@ -73,7 +73,9 @@ QString NCore::rcDir()
     if (!_rcDir_init) {
 #ifndef Q_OS_WIN
         QDir parentDir(QCoreApplication::applicationDirPath());
-        if (parentDir.dirName() == "bin") {
+        // Qt4: On macOS, check for .app bundle structure (Contents/MacOS)
+        // Also check for standard bin directory installations
+        if (parentDir.dirName() == "bin" || parentDir.dirName() == "MacOS") {
             _rcDir = QDir::homePath() + "/.nulloy";
         } else {
             _rcDir = QCoreApplication::applicationDirPath();
@@ -102,7 +104,8 @@ QString NCore::rcDir()
 #endif
         QDir dir(_rcDir);
         if (!dir.exists()) {
-            dir.mkdir(_rcDir);
+            // Qt4: Use mkpath() to create directory and any parent directories
+            QDir().mkpath(_rcDir);
         }
 
         _rcDir_init = true;
diff --git a/src/interfaces/coverReaderInterface.h b/src/interfaces/coverReaderInterface.h
index ee45a4e..13d2da4 100644
--- a/src/interfaces/coverReaderInterface.h
+++ b/src/interfaces/coverReaderInterface.h
@@ -16,6 +16,8 @@
 #ifndef N_COVER_ART_READER_INTERFACE_H
 #define N_COVER_ART_READER_INTERFACE_H
 
+#include <QImage>
+#include <QList>
 #include <QObject>
 
 class QString;
diff --git a/src/interfaces/tagReaderInterface.h b/src/interfaces/tagReaderInterface.h
index a216a31..4c48cf9 100644
--- a/src/interfaces/tagReaderInterface.h
+++ b/src/interfaces/tagReaderInterface.h
@@ -38,7 +38,7 @@ public:
 
     virtual bool isWriteSupported() const { return false; }
     virtual QMap<QString, QStringList> getTags() const { return QMap<QString, QStringList>(); }
-    virtual QMap<QString, QStringList> setTags(const QMap<QString, QStringList> &) {}
+    virtual QMap<QString, QStringList> setTags(const QMap<QString, QStringList> &) { return QMap<QString, QStringList>(); }
 };
 
 Q_DECLARE_INTERFACE(NTagReaderInterface, TAGREADER_INTERFACE)
diff --git a/src/main.cpp b/src/main.cpp
index 34868d8..4f0e791 100644
--- a/src/main.cpp
+++ b/src/main.cpp
@@ -21,7 +21,8 @@
 
 #ifndef _N_NO_SKINS_
 #include "skinFileSystem.h"
-Q_IMPORT_PLUGIN(NWidgetCollection)
+// Qt4 Q_IMPORT_PLUGIN must match Q_EXPORT_PLUGIN2 first parameter
+Q_IMPORT_PLUGIN(widgetcollection)
 #endif
 
 bool logToFile = false;
@@ -56,17 +57,16 @@ static void print_try()
     print_out("Try `" + NCore::applicationBasenameName() + " --help' for more information");
 }
 
-void messageHandler(QtMsgType type, const QMessageLogContext &context, const QString &msg)
+// Qt4 uses different message handler signature (no QMessageLogContext, const char* instead of QString)
+void messageHandler(QtMsgType type, const char *msg)
 {
-    Q_UNUSED(context);
-    print_err(msg);
+    QString message = QString::fromLocal8Bit(msg);
+    print_err(message);
 
     if (logToFile) {
         QString prefix;
         switch (type) {
-            case QtInfoMsg:
-                prefix = "Info";
-                break;
+            // QtInfoMsg doesn't exist in Qt4, added in Qt5
             case QtDebugMsg:
                 prefix = "Debug";
                 break;
@@ -85,7 +85,7 @@ void messageHandler(QtMsgType type, const QMessageLogContext &context, const QSt
         QTextStream stream(&logFile);
         stream << QString("%1 %2: %3")
                       .arg(QTime::currentTime().toString("hh:mm:ss.zzz"), prefix,
-                           msg.toLocal8Bit().constData())
+                           message.toLocal8Bit().constData())
                << endl;
         logFile.close();
     }
@@ -100,8 +100,7 @@ int main(int argc, char *argv[])
     QCoreApplication::addLibraryPath(QFileInfo(argv[0]).dir().path() + "/plugins/");
 #endif
 
-    QCoreApplication::setAttribute(Qt::AA_UseHighDpiPixmaps);
-    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
+    // Qt4 doesn't support HiDPI attributes (AA_UseHighDpiPixmaps and AA_EnableHighDpiScaling are Qt5+)
 
 #ifdef Q_OS_MAC
     // https://bugreports.qt-project.org/browse/QTBUG-32789
@@ -119,7 +118,8 @@ int main(int argc, char *argv[])
     instance.setOrganizationDomain("nulloy.com");
     instance.setQuitOnLastWindowClosed(false);
 
-    qInstallMessageHandler(messageHandler);
+    // Qt4 uses qInstallMsgHandler() instead of Qt5's qInstallMessageHandler()
+    qInstallMsgHandler(messageHandler);
 
     QStringList argList = instance.arguments();
     argList.takeFirst();
diff --git a/src/mainWindow.cpp b/src/mainWindow.cpp
index 0a7ec55..c53293e 100644
--- a/src/mainWindow.cpp
+++ b/src/mainWindow.cpp
@@ -19,7 +19,7 @@
 #include "settings.h"
 
 #ifndef _N_NO_SKINS_
-#include <QUiLoader>
+#include "customUiLoader.h"
 
 #include "skinFileSystem.h"
 #endif
@@ -35,6 +35,7 @@
 #endif
 #endif
 
+#include <QAbstractItemView>
 #include <QApplication>
 #include <QDesktopWidget>
 #include <QEvent>
@@ -54,7 +55,7 @@ NMainWindow::NMainWindow(const QString &uiFile, QWidget *parent) : QDialog(paren
     setObjectName("mainWindow");
 
 #ifndef _N_NO_SKINS_
-    QUiLoader loader;
+    NCustomUiLoader loader;
     QFile formFile(uiFile);
     formFile.open(QIODevice::ReadOnly);
     QWidget *form = loader.load(&formFile);
@@ -66,6 +67,31 @@ NMainWindow::NMainWindow(const QString &uiFile, QWidget *parent) : QDialog(paren
     setLayout(layout);
     setStyleSheet(form->styleSheet());
     form->setStyleSheet("");
+
+    // Qt4: Explicitly enable acceptDrops and dragEnabled for custom widgets AFTER reparenting
+    // QUiLoader in Qt4 may not properly apply these properties from .ui file
+    // Must be done after widgets are added to the main window layout
+    QList<QWidget *> allWidgets = findChildren<QWidget *>();
+    foreach (QWidget *widget, allWidgets) {
+        QString className = widget->metaObject()->className();
+        if (className == "NPlaylistWidget") {
+            widget->setAcceptDrops(true);
+            // Also ensure drag-drop mode is set for QListWidget-based widgets
+            QAbstractItemView *itemView = qobject_cast<QAbstractItemView *>(widget);
+            if (itemView) {
+                itemView->setDragDropMode(QAbstractItemView::DragDrop);
+                itemView->setDragEnabled(true);
+                itemView->setAcceptDrops(true);
+                itemView->setDropIndicatorShown(true);
+                // Qt4: Ensure viewport also accepts drops
+                if (itemView->viewport()) {
+                    itemView->viewport()->setAcceptDrops(true);
+                }
+            }
+        } else if (className == "NWaveformSlider") {
+            widget->setAcceptDrops(true);
+        }
+    }
 #else
     Q_UNUSED(uiFile)
     ui.setupUi(this);
@@ -450,7 +476,9 @@ void NMainWindow::wheelEvent(QWheelEvent *event)
 {
     QDialog::wheelEvent(event);
 
-    if (event->orientation() == Qt::Vertical) {
+    // Qt4: Only emit scrolled for global volume control if the event
+    // was not already handled by a child widget (like playlist scrolling)
+    if (event->orientation() == Qt::Vertical && !event->isAccepted()) {
         emit scrolled(event->delta());
     }
 }
diff --git a/src/messageBox.cpp b/src/messageBox.cpp
index 578d460..427d71e 100644
--- a/src/messageBox.cpp
+++ b/src/messageBox.cpp
@@ -20,7 +20,7 @@
 #include "messageBox.h"
 
 NMessageBox::NMessageBox(int width, QObject &centerInTarget, QWidget *parent)
-    : QMessageBox(parent), m_centerInWindow{centerInTarget}
+    : QMessageBox(parent), m_centerInWindow(centerInTarget)
 {
     m_width = width;
     m_resized = false;
diff --git a/src/messageBox.h b/src/messageBox.h
index 7e91728..61da432 100644
--- a/src/messageBox.h
+++ b/src/messageBox.h
@@ -18,10 +18,10 @@
 class NMessageBox : public QMessageBox
 {
 public:
-    NMessageBox(int width, QObject &centerInTarget, QWidget *parent = nullptr);
+    NMessageBox(int width, QObject &centerInTarget, QWidget *parent = 0);
 
 protected:
-    void resizeEvent(QResizeEvent *event) override;
+    void resizeEvent(QResizeEvent *event);
 
 private:
     int m_width;
diff --git a/src/platform/trash.cpp b/src/platform/trash.cpp
index 074fcbc..55fca41 100644
--- a/src/platform/trash.cpp
+++ b/src/platform/trash.cpp
@@ -20,6 +20,7 @@
 #include <QCheckBox>
 #include <QFile>
 #include <QFileInfo>
+#include <QGridLayout>
 #include <QMessageBox>
 #include <QProcess>
 
@@ -38,7 +39,11 @@ QStringList NTrash::moveToTrash(QStringList files)
                                    .arg(QFileInfo(file).fileName()),
                                QMessageBox::Yes | QMessageBox::Cancel, NULL);
             msgBox.setDefaultButton(QMessageBox::Cancel);
-            msgBox.setCheckBox(checkBox);
+            // Qt4 doesn't have setCheckBox(), add checkbox manually to layout
+            QGridLayout *layout = qobject_cast<QGridLayout *>(msgBox.layout());
+            if (layout) {
+                layout->addWidget(checkBox, layout->rowCount(), 0, 1, layout->columnCount());
+            }
             int res = msgBox.exec();
 
             if (res != QMessageBox::Yes) {
diff --git a/src/player.cpp b/src/player.cpp
index 32d1da6..e672201 100644
--- a/src/player.cpp
+++ b/src/player.cpp
@@ -71,7 +71,12 @@ NPlayer::NPlayer()
 
     QString styleName = m_settings->value("Style").toString();
     if (!styleName.isEmpty()) {
-        QApplication::setStyle(styleName);
+        // Qt4: Normalize style names (remove parenthetical additions)
+        // "Macintosh (aqua)" -> "Macintosh"
+        styleName = styleName.split('(').first().trimmed();
+        if (!styleName.isEmpty()) {
+            QApplication::setStyle(styleName);
+        }
     }
 
     NI18NLoader::init();
@@ -175,13 +180,12 @@ NPlayer::NPlayer()
     connectSignals();
 
     m_settingsSaveTimer = new QTimer(this);
-    connect(m_settingsSaveTimer, &QTimer::timeout, [this]() { saveSettings(); });
+    connect(m_settingsSaveTimer, SIGNAL(timeout()), this, SLOT(on_settingsSaveTimer_timeout()));
     m_settingsSaveTimer->start(5000); // 5 seconds
 
     m_writeDefaultPlaylistTimer = new QTimer(this);
     m_writeDefaultPlaylistTimer->setSingleShot(true);
-    connect(m_writeDefaultPlaylistTimer, &QTimer::timeout,
-            [this]() { writePlaylist(NCore::defaultPlaylistPath(), N::NulloyM3u); });
+    connect(m_writeDefaultPlaylistTimer, SIGNAL(timeout()), this, SLOT(on_writeDefaultPlaylistTimer_timeout()));
 }
 
 NPlayer::~NPlayer()
@@ -213,8 +217,8 @@ void NPlayer::connectSignals()
 
     connect(m_mainWindow, SIGNAL(closed()), this, SLOT(on_mainWindow_closed()));
 
-    connect(m_preferencesDialog, &NPreferencesDialog::settingsChanged, this,
-            &NPlayer::applySettings);
+    connect(m_preferencesDialog, SIGNAL(settingsChanged()), this,
+            SLOT(applySettings()));
 
     if (QAbstractButton *playButton = m_mainWindow->findChild<QAbstractButton *>("playButton")) {
         connect(playButton, SIGNAL(clicked()), this, SLOT(playPause()));
@@ -263,45 +267,24 @@ void NPlayer::connectSignals()
 
     connect(m_playlistWidget, SIGNAL(addMoreRequested()), this,
             SLOT(on_playlist_addMoreRequested()));
-    connect(m_playlistWidget, &NPlaylistWidget::durationChanged, [this](int durationSec) {
-        NPlaylistWidgetItem *item = m_playlistWidget->playingItem();
-        if (item) {
-            m_trackInfoReader->setSource(item->data(N::PathRole).toString());
-        }
-
-        m_trackInfoReader->updatePlaylistDuration(durationSec);
-
-        m_trackInfoWidget->updatePlaylistLabels();
-
-        QString format = NSettings::instance()->value("WindowTitleTrackInfo").toString();
-        if (!format.isEmpty()) {
-            QString title = m_trackInfoReader->toString(format);
-            m_mainWindow->setTitle(title);
-        }
-    });
-    connect(m_playlistWidget, &NPlaylistWidget::itemsChanged, [this]() {
-        m_writeDefaultPlaylistTimer->start(100); //
-    });
-    connect(m_playlistWidget, &NPlaylistWidget::playingItemChanged,
-            [this]() { savePlaybackState(); });
-    connect(m_playlistWidget, &NPlaylistWidget::playlistFinished, [this]() {
-        if (NSettings::instance()->value("QuitWhenFinished").toBool()) {
-            QCoreApplication::quit();
-        }
-    });
-
-    connect(m_waveformSlider, &NWaveformSlider::filesDropped,
-            [this](const QList<NPlaylistDataItem> &dataItems) {
-                m_playlistWidget->setItems(dataItems);
-                m_playlistWidget->playRow(0);
-            });
+    connect(m_playlistWidget, SIGNAL(durationChanged(int)), this,
+            SLOT(on_playlistWidget_durationChanged(int)));
+    connect(m_playlistWidget, SIGNAL(itemsChanged()), this,
+            SLOT(on_playlistWidget_itemsChanged()));
+    connect(m_playlistWidget, SIGNAL(playingItemChanged()),
+            this, SLOT(on_playlistWidget_playingItemChanged()));
+    connect(m_playlistWidget, SIGNAL(playlistFinished()), this,
+            SLOT(on_playlistWidget_playlistFinished()));
+
+    connect(m_waveformSlider, SIGNAL(filesDropped(QList<NPlaylistDataItem>)),
+            this, SLOT(on_waveformSlider_filesDropped(QList<NPlaylistDataItem>)));
     connect(m_waveformSlider, SIGNAL(sliderMoved(qreal)), m_playbackEngine,
             SLOT(setPosition(qreal)));
 
     connect(m_mainWindow, SIGNAL(customContextMenuRequested(const QPoint &)), this,
             SLOT(showContextMenu(const QPoint &)));
-    connect(m_playlistWidget, &NPlaylistWidget::contextMenuRequested, this,
-            &NPlayer::showPlaylistContextMenu);
+    connect(m_playlistWidget, SIGNAL(contextMenuRequested(QPoint)), this,
+            SLOT(showPlaylistContextMenu(QPoint)));
     connect(m_systemTray, SIGNAL(activated(QSystemTrayIcon::ActivationReason)), this,
             SLOT(on_trayIcon_activated(QSystemTrayIcon::ActivationReason)));
     connect(m_trayClickTimer, SIGNAL(timeout()), this, SLOT(on_trayClickTimer_timeout()));
@@ -406,6 +389,8 @@ void NPlayer::loadDefaultPlaylist()
         return;
     }
 
+    // Qt4: Don't auto-play on startup, only restore playlist position
+    // User must explicitly press play if they want to resume playback
     QStringList playlistRowValues = m_settings->value("PlaylistRow").toStringList();
     if (!playlistRowValues.isEmpty()) {
         int row = playlistRowValues.at(0).toInt();
@@ -415,26 +400,22 @@ void NPlayer::loadDefaultPlaylist()
             return;
         }
 
-        if (!m_settings->value("StartPaused").toBool()) {
-            m_playlistWidget->playRow(row);
-            m_playbackEngine->setPosition(pos);
-        } else { // do the work that would have been done upon m_playbackEngine::mediaChanged()
-            NPlaylistWidgetItem *item = m_playlistWidget->itemAtRow(row);
-            m_playlistWidget->setPlayingItem(item);
+        // Set the playing item and media but don't start playback
+        NPlaylistWidgetItem *item = m_playlistWidget->itemAtRow(row);
+        m_playlistWidget->setPlayingItem(item);
 
-            QString file = item->data(N::PathRole).toString();
-            int id = item->data(N::IdRole).toInt();
+        QString file = item->data(N::PathRole).toString();
+        int id = item->data(N::IdRole).toInt();
 
-            m_playbackEngine->setMedia(file, id);
-            m_playbackEngine->setPosition(pos);
+        m_playbackEngine->setMedia(file, id);
+        m_playbackEngine->setPosition(pos);
 
-            loadCoverArt(file);
+        loadCoverArt(file);
 
-            m_waveformSlider->setMedia(file);
-            m_waveformSlider->setValue(pos);
-            m_waveformSlider->setPausedState(true);
-            m_trackInfoWidget->updateFileLabels(file);
-        }
+        m_waveformSlider->setMedia(file);
+        m_waveformSlider->setValue(pos);
+        m_waveformSlider->setPausedState(true);
+        m_trackInfoWidget->updateFileLabels(file);
     }
 }
 
@@ -468,6 +449,8 @@ void NPlayer::saveSettings()
     m_mainWindow->saveSettings();
     savePlaybackState();
     m_actionManager->saveSettings();
+    // Qt4: Explicitly sync settings to disk after periodic save
+    m_settings->sync();
 }
 
 void NPlayer::savePlaybackState()
@@ -843,7 +826,9 @@ bool NPlayer::revealInFileManager(const QString &file, QString *error) const
         cmd.replace("%P", canonicalPath);
 
 #if !defined Q_OS_WIN
-        res = QProcess::execute("sh", QStringList{"-c", cmd});
+        QStringList args;
+        args << "-c" << cmd;
+        res = QProcess::execute("sh", args);
 #else
         res = QProcess::execute(cmd);
 #endif
@@ -852,16 +837,16 @@ bool NPlayer::revealInFileManager(const QString &file, QString *error) const
         QStringList args;
 #if defined Q_OS_WIN
         cmd = "explorer.exe";
-        args = QStringList{"/n", ",", "/select", ",", path.replace('/', '\\')};
+        args << "/n" << "," << "/select" << "," << path.replace('/', '\\');
 #elif defined Q_OS_LINUX
         cmd = "xdg-open";
-        args = QStringList{fileInfo.canonicalPath().replace("'", "'\\''")};
+        args << fileInfo.canonicalPath().replace("'", "'\\''");
 #elif defined Q_OS_MAC
         cmd = "open";
-        args = QStringList{"-R", path.replace("'", "'\\''")};
+        args << "-R" << path.replace("'", "'\\''");
 #endif
         res = QProcess::execute(cmd, args);
-        cmd += " " + args.join(' ');
+        cmd += " " + args.join(QString(" "));
     }
 
 #ifndef Q_OS_WIN
@@ -876,3 +861,54 @@ bool NPlayer::revealInFileManager(const QString &file, QString *error) const
 
     return true;
 }
+
+void NPlayer::on_settingsSaveTimer_timeout()
+{
+    saveSettings();
+}
+
+void NPlayer::on_writeDefaultPlaylistTimer_timeout()
+{
+    writePlaylist(NCore::defaultPlaylistPath(), N::NulloyM3u);
+}
+
+void NPlayer::on_playlistWidget_durationChanged(int durationSec)
+{
+    NPlaylistWidgetItem *item = m_playlistWidget->playingItem();
+    if (item) {
+        m_trackInfoReader->setSource(item->data(N::PathRole).toString());
+    }
+
+    m_trackInfoReader->updatePlaylistDuration(durationSec);
+
+    m_trackInfoWidget->updatePlaylistLabels();
+
+    QString format = NSettings::instance()->value("WindowTitleTrackInfo").toString();
+    if (!format.isEmpty()) {
+        QString title = m_trackInfoReader->toString(format);
+        m_mainWindow->setTitle(title);
+    }
+}
+
+void NPlayer::on_playlistWidget_itemsChanged()
+{
+    m_writeDefaultPlaylistTimer->start(100);
+}
+
+void NPlayer::on_playlistWidget_playingItemChanged()
+{
+    savePlaybackState();
+}
+
+void NPlayer::on_playlistWidget_playlistFinished()
+{
+    if (NSettings::instance()->value("QuitWhenFinished").toBool()) {
+        QCoreApplication::quit();
+    }
+}
+
+void NPlayer::on_waveformSlider_filesDropped(const QList<NPlaylistDataItem> &dataItems)
+{
+    m_playlistWidget->setItems(dataItems);
+    m_playlistWidget->playRow(0);
+}
diff --git a/src/player.h b/src/player.h
index dad9890..c0835c9 100644
--- a/src/player.h
+++ b/src/player.h
@@ -28,6 +28,7 @@ class NPlaylistWidget;
 class NWaveformSlider;
 class NCoverWidget;
 class NCoverReaderInterface;
+struct NPlaylistDataItem;
 class NVolumeSlider;
 class NPreferencesDialog;
 class NAboutDialog;
@@ -101,6 +102,14 @@ private slots:
     void on_trayClickTimer_timeout();
     void trayIconCountClicks(int clicks);
 
+    void on_settingsSaveTimer_timeout();
+    void on_writeDefaultPlaylistTimer_timeout();
+    void on_playlistWidget_durationChanged(int durationSec);
+    void on_playlistWidget_itemsChanged();
+    void on_playlistWidget_playingItemChanged();
+    void on_playlistWidget_playlistFinished();
+    void on_waveformSlider_filesDropped(const QList<NPlaylistDataItem> &dataItems);
+
 public slots:
     void quit();
     void playPause();
diff --git a/src/plugins/pluginGstreamer/containerGstreamer.cpp b/src/plugins/pluginGstreamer/containerGstreamer.cpp
index 2340267..1e8d3b0 100644
--- a/src/plugins/pluginGstreamer/containerGstreamer.cpp
+++ b/src/plugins/pluginGstreamer/containerGstreamer.cpp
@@ -43,3 +43,5 @@ QList<NPlugin *> NContainerGstreamer::plugins() const
 {
     return m_plugins;
 }
+
+Q_EXPORT_PLUGIN2(containerGstreamer, NContainerGstreamer)
diff --git a/src/plugins/pluginGstreamer/containerGstreamer.h b/src/plugins/pluginGstreamer/containerGstreamer.h
index 93b9f2c..cf41956 100644
--- a/src/plugins/pluginGstreamer/containerGstreamer.h
+++ b/src/plugins/pluginGstreamer/containerGstreamer.h
@@ -22,7 +22,6 @@ class NContainerGstreamer : public QObject, public NPluginContainer
 {
     Q_OBJECT
     Q_INTERFACES(NPluginContainer)
-    Q_PLUGIN_METADATA(IID "com.nulloy.NContainerGstreamer")
 
 private:
     QList<NPlugin *> m_plugins;
diff --git a/src/plugins/pluginGstreamer/playbackEngineGstreamer.cpp b/src/plugins/pluginGstreamer/playbackEngineGstreamer.cpp
index af1c932..ec57a57 100644
--- a/src/plugins/pluginGstreamer/playbackEngineGstreamer.cpp
+++ b/src/plugins/pluginGstreamer/playbackEngineGstreamer.cpp
@@ -121,18 +121,11 @@ void NPlaybackEngineGStreamer::init()
     m_emitStateTimer = new QTimer(this);
     m_emitStateTimer->setSingleShot(true);
     m_emitStateTimer->setInterval(STATE_CHANGE_DEBOUNCE_MSEC);
-    connect(m_emitStateTimer, &QTimer::timeout,
-            [this]() { emit stateChanged(fromGstState(m_gstState)); });
+    connect(m_emitStateTimer, SIGNAL(timeout()), this, SLOT(on_emitStateTimer_timeout()));
 
     m_gstBusPopTimer = new QTimer(this);
     m_gstBusPopTimer->setInterval(GST_BUS_POP_MSEC);
-    connect(m_gstBusPopTimer, &QTimer::timeout, [this]() {
-        GstBus *bus = gst_pipeline_get_bus(GST_PIPELINE(m_playbin));
-        GstMessage *msg;
-        while ((msg = gst_bus_pop(bus)) != NULL) {
-            processGstMessage(msg);
-        }
-    });
+    connect(m_gstBusPopTimer, SIGNAL(timeout()), this, SLOT(on_gstBusPopTimer_timeout()));
 
     m_init = true;
 }
@@ -376,7 +369,7 @@ void NPlaybackEngineGStreamer::processGstMessage(GstMessage *msg)
                 gchar *detail = gst_missing_plugin_message_get_installer_detail(msg);
                 if (detail) {
                     QStringList fields = QString::fromUtf8(detail).split('|').mid(3);
-                    str += QString::fromUtf8(detail).split('|').mid(3).join("<br/>");
+                    str += fields.join("<br/>");
                     g_free(detail);
                 } else {
                     str += tr("Unknown plugin");
@@ -486,3 +479,17 @@ bool NPlaybackEngineGStreamer::_nextMediaRequestBlocked()
 {
     return m_nextMediaRequestBlock;
 }
+
+void NPlaybackEngineGStreamer::on_emitStateTimer_timeout()
+{
+    emit stateChanged(fromGstState(m_gstState));
+}
+
+void NPlaybackEngineGStreamer::on_gstBusPopTimer_timeout()
+{
+    GstBus *bus = gst_pipeline_get_bus(GST_PIPELINE(m_playbin));
+    GstMessage *msg;
+    while ((msg = gst_bus_pop(bus)) != NULL) {
+        processGstMessage(msg);
+    }
+}
diff --git a/src/plugins/pluginGstreamer/playbackEngineGstreamer.h b/src/plugins/pluginGstreamer/playbackEngineGstreamer.h
index 35be620..05b8fff 100644
--- a/src/plugins/pluginGstreamer/playbackEngineGstreamer.h
+++ b/src/plugins/pluginGstreamer/playbackEngineGstreamer.h
@@ -57,6 +57,10 @@ private:
     void processGstMessage(GstMessage *msg);
     void fail();
 
+private slots:
+    void on_emitStateTimer_timeout();
+    void on_gstBusPopTimer_timeout();
+
 public:
     NPlaybackEngineGStreamer(QObject *parent = NULL) : NPlaybackEngineInterface(parent) {}
     ~NPlaybackEngineGStreamer();
diff --git a/src/plugins/pluginTaglib/containerTaglib.cpp b/src/plugins/pluginTaglib/containerTaglib.cpp
index f6ce5d9..7dba764 100644
--- a/src/plugins/pluginTaglib/containerTaglib.cpp
+++ b/src/plugins/pluginTaglib/containerTaglib.cpp
@@ -33,3 +33,5 @@ QList<NPlugin *> NContainerTaglib::plugins() const
 {
     return m_plugins;
 }
+
+Q_EXPORT_PLUGIN2(containerTaglib, NContainerTaglib)
diff --git a/src/plugins/pluginTaglib/containerTaglib.h b/src/plugins/pluginTaglib/containerTaglib.h
index a0b4999..c3a2d3a 100644
--- a/src/plugins/pluginTaglib/containerTaglib.h
+++ b/src/plugins/pluginTaglib/containerTaglib.h
@@ -22,7 +22,6 @@ class NContainerTaglib : public QObject, public NPluginContainer
 {
     Q_OBJECT
     Q_INTERFACES(NPluginContainer)
-    Q_PLUGIN_METADATA(IID "com.nulloy.NContainerTaglib")
 
 private:
     QList<NPlugin *> m_plugins;
